<?php
/**
* +----------------------------------------------------------------------+
* | F Board                                                              |
* +----------------------------------------------------------------------+
* | Copyright (c) 2003 Fguy (http://fguy.com)                            |
* +----------------------------------------------------------------------+
* | This software licensed under the GPL license and is provided "as is" |
* | and is without any warranty.                                         |
* |                                                                      |
* | You need to purchase commercial licenses:                            |
* |                                                                      |
* | 1. If you distribute this Software with your non open source         |
* |    software.                                                         |
* | 2. If you want warranty for this software.                           |
* | 3. If you want to support development.                               |
* |                                                                      |
* | Licenses, Support and Training can be easily purchased online.       |
* +----------------------------------------------------------------------+
* | Author: Kang Tae Hoon <fguy@fguy.com>                                |
* +----------------------------------------------------------------------+
*
* Խ 
*
* @author fguy <fguy@fguy.com>
* @version 0.5
* @access public
* @package FBoard
*/
	require_once "lib/Schema.php";

	$schema = new Schema($settings, $sql);

	switch($_GET[mode])
	{
		// Խ 
		case "create" :

			$board_id = $schema->createBoard($connection, $_GET[gid], $session->get("email"));

			if(!$board_id)
				alert($settings->messages[failed_to_create]);
			else
			{
				echo "board " . $board_id . " created";
				echo "<script>parent.location.href='admin.php?module=board&mode=edit&id=" . $board_id ."&selected=b" . $board_id ."'</script>";
			}

/*			if($schema->createBoard($connection, $_POST[parent], $_POST[name], $_POST[access_level]))
			{
				alert($settings->messages[created], $_POST[href]);
			}
*/
			break;
		
		// Խ 
		case "delete" :

			$group_id = $connection->getOne("select gid from " . $settings->prefix . "_board_config where id = " . $_GET[id]);

			if(!$schema->deleteBoard($connection,$_GET[id]))
				alert($settings->messages[failed_to_delete_board]);
			else
			{
				recursiveDelete($settings->uploaded_file_path . $_GET[id]);

				alert($settings->messages[deleted], "admin.php");
			}

			break;

		// Խ   
		case "update" :

			if(ereg("\|" , $_POST[name]))
				alert($settings->messages[name] . $settings->messages[is_containing_invalid_string]);

			$values = $_POST;

			$keys = array("name", "admin", "gid", "skin", "bgcolor", "background", "header_file", "footer_file", "width", "subject_length", "body_length", "list_per_page", "pages", "max_file_size", "latest_standard", "cool_standard", "papering_standard", "use_category", "use_html", "use_comment", "use_filtering", "use_related_link", "use_upload", "use_list", "use_body_in_list", "use_vote", "use_file_preview", "use_inform_to_admin");

			$values = $sql->getValidValues($values, $keys);

			$result = $connection->autoExecute($settings->prefix . "_board_config", $values, DB_AUTOQUERY_UPDATE, "id=" . $_POST[id]);

			if(DB::isError($result))
				alert($settings->messages[failed_to_update] . " " . $result->getMessage() . " on " . __FILE__ . " line " . __LINE__, "javascript:void(0)");

			//echo "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=" . $settings->encoding . "\"><script>alert('" . $settings->messages[updated] . "');void(0);parent.document.all.dynamicData.src = 'js/tree.php?selected=b" . $_POST[id] . "';</script>";
			redirect("admin.php?module=board&mode=edit&id=" . $_POST[id] . "&selected=b" . $_POST[id]);
			break;


		// Խ   
		case "edit" : 

			$tpl = new Template($settings->skin_path . "_admin");

			$tpl->loadTemplatefile("board.html",true, true);

			$tpl->setVariable("HEADER", $header);

			$tpl->setVariable("FOOTER", $footer);

			$result = $connection->query("select * from " . $settings->prefix . "_board_config where id=" . $_GET[id]);

			if(DB::isError($result))
			{
				print_r($result);
				alert($result->getMessage() . " on " . __FILE__ . " line " . __LINE__);
			}

			if($result->numRows() < 1)
				alert($settings->messages[not_exists]);

			$row = $result->fetchRow(DB_FETCHMODE_ASSOC);

			unset($result);

			//  ȯ
			foreach($row as $key => $val)
			{
				$tpl->setVariable(strtoupper($key), $val);
			}


			// ׷  
			$result = $connection->query("select gid, name from " . $settings->prefix . "_group where gid != 1 order by name");

			if(DB::isError($result))
			{
				alert($result->getMessage() . " on " . __FILE__ . " line " . __LINE__);
			}

			while($row = $result->fetchRow())
			{
				$tpl->setCurrentBlock("group");
				$tpl->setVariable("GROUP_ID", $row[0]);
				$tpl->setVariable("GROUP_NAME", $row[1]);
				$tpl->parseCurrentBlock("group");
			}

			// Ų  о
			$dir = opendir($settings->skin_path);
			while($skindir = readdir($dir))
			{
				if(!eregi("\.",$skindir) && substr($skindir,0,1) != "_")
				{
					$tpl->setCurrentBlock("skin");
					$tpl->setVariable("SKIN_PATH", $skindir);
					$tpl->parseCurrentBlock("skin");
				}
			}
			closedir($dir);

			// ޼ ȯ
			foreach($settings->messages as $key => $val)
			{
				$tpl->setVariable("MSG_" . strtoupper($key), $val);
			}
			$tpl->setVariable("ACTION", "admin.php?module=board&mode=update");
			$tpl->show();

			break;
	}

	function recursiveDelete($dir)
	{
	  if ($handle = @opendir($dir))
	  {
		 while (($file = @readdir($handle)) !== false)
		 {
			if (($file == ".") || ($file == ".."))
			{
			   continue;
			}
		  if (@is_dir($dir . '/' . $file))
			{
			   // call self for this directory
			   recursiveDelete($dir . '/' . $file);
			}
			else
			{
			  @unlink($dir . '/' . $file); // remove this file
			}
		}
		 @closedir($handle);
		 @rmdir ($dir);  
	  }
	}
?>