<?php
/**
* +----------------------------------------------------------------------+
* | F Board                                                              |
* +----------------------------------------------------------------------+
* | Copyright (c) 2003 Fguy (http://fguy.com)                            |
* +----------------------------------------------------------------------+
* | This software licensed under the GPL license and is provided "as is" |
* | and is without any warranty.                                         |
* |                                                                      |
* | You need to purchase commercial licenses:                            |
* |                                                                      |
* | 1. If you distribute this Software with your non open source         |
* |    software.                                                         |
* | 2. If you want warranty for this software.                           |
* | 3. If you want to support development.                               |
* |                                                                      |
* | Licenses, Support and Training can be easily purchased online.       |
* +----------------------------------------------------------------------+
* | Author: Kang Tae Hoon <fguy@fguy.com>                                |
* +----------------------------------------------------------------------+
*
* з 
*
* @author fguy <fguy@fguy.com>
* @version 0.5
* @access public
* @package FBoard
*/
	require_once "lib/Schema.php";

	$schema = new Schema($settings, $sql);

	switch($_GET[mode])
	{
		case "create" : 

			$num = $connection->getOne("select max(num) + 1 from " . $settings->prefix . "_category where id = " . $_POST[id]);

			if(DB::isError($num) || !$num)
				$num = 0;

			$values = array("id" => $_POST[id], "num" => $num, "label" => trim($_POST[label]));
			
			$result = $connection->autoExecute($settings->prefix . "_category", $values);

			if(DB::isError($result))
				alert($settings->messages[failed_to_create] . " " . $result->getMessage() . " on " . __FILE__ . " line " . __LINE__);
			else
				redirect("admin.php?module=category&id=" . $_POST[id]);

			break;

		case "update" :

			$values = array("label" => trim($_POST[label]));

			$result = $connection->autoExecute($settings->prefix . "_category", $values, DB_AUTOQUERY_UPDATE, "id=" . $_POST[id] . " and num = " . $_POST[num]);

			if(DB::isError($result))
				alert($settings->messages[failed_to_update] . " " . $result->getMessage() . " on " . __FILE__ . " line " . __LINE__);
			else
				redirect("admin.php?module=category&id=" . $_POST[id]);

			break;

		case "delete" :

			$result = $connection->query("delete from " . $settings->prefix . "_category where num=" . $_GET[num] . " and id=" . $_GET[id]);

			redirect("admin.php?module=category&id=" . $_GET[id]);

			break;

		default :

			$board_name = $connection->getOne("select name from " . $settings->prefix . "_board_config where id = " . $_GET[id]);

			$tpl = new Template($settings->skin_path . "_admin");

			$tpl->loadTemplatefile("category.html",true, true);

			// ޼ ȯ
			foreach($settings->messages as $key => $val)
			{
				$tpl->setVariable("MSG_" . strtoupper($key), $val);
			}

			$tpl->setVariable("NAME", $board_name);

			$tpl->setVariable("ENCODING", $settings->encoding);


			$result = $connection->query("select * from " . $settings->prefix . "_category where id=" . $_GET[id]);

			if(DB::isError($result))
			{
				alert($result->getMessage() . " on " . __FILE__ . " line " . __LINE__);
			}

			if($result->numRows() < 1)
				alert($settings->messages[not_exists]);

			while($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
			{
					$tpl->setCurrentBlock("category");

					$tpl->setVariable("ID", $_GET[id]);

					$tpl->setVariable("NUM", $row[num]);

					$tpl->setVariable("LABEL", $row[label]);

					$tpl->setVariable("MSG_CONFIRM_DELETE", $settings->messages[confirm_delete]);

					$tpl->setVariable("MSG_DELETE", $settings->messages['delete']);

					$tpl->setVariable("MSG_UPDATE", $settings->messages[update]);

					$tpl->parseCurrentBlock("category");
			}

			unset($result);

			$tpl->setVariable("ID", $_GET[id]);


			$tpl->show();

			break;
	}
?>