<?php
/**
* +----------------------------------------------------------------------+
* | F Board                                                              |
* +----------------------------------------------------------------------+
* | Copyright (c) 2003 Fguy (http://fguy.com)                            |
* +----------------------------------------------------------------------+
* | This software licensed under the GPL license and is provided "as is" |
* | and is without any warranty.                                         |
* |                                                                      |
* | You need to purchase commercial licenses:                            |
* |                                                                      |
* | 1. If you distribute this Software with your non open source         |
* |    software.                                                         |
* | 2. If you want warranty for this software.                           |
* | 3. If you want to support development.                               |
* |                                                                      |
* | Licenses, Support and Training can be easily purchased online.       |
* +----------------------------------------------------------------------+
* | Author: Kang Tae Hoon <fguy@fguy.com>                                |
* +----------------------------------------------------------------------+
*
* Common included global functions and variables (non class)
*
* @author fguy <fguy@fguy.com>
* @version 0.5
* @access public
* @package FBoard
*/
	// α׷  ð
	$start_time = get_micro_time();

	// UNIX MICRO TIMESTAMP  
	function get_micro_time()
	{
		$microtimestmp = split(" ",microtime());
		return $microtimestmp[0]+$microtimestmp[1];
	}

	// α׷  ð 
	function get_exec_time()
	{
		global $start_time;

		// α׷  ð
		$end_time = get_micro_time();

		return abs($end_time - $start_time);
	}

	/*    ȣȯ Ȯ */
	/*
	if(preg_match('/^4\.0/',PHP_VERSION))
	{
		$GLOBALS[_SERVER] = array_merge($GLOBALS[HTTP_SERVER_VARS],$_SERVER);
		$GLOBALS[_GET] = $GLOBALS[HTTP_GET_VARS];
		$GLOBALS[_POST] = $GLOBALS[HTTP_POST_VARS];
		$GLOBALS[_COOKIE] = $GLOBALS[HTTP_COOKIE_VARS];
		$GLOBALS[_SESSION] = $GLOBALS[HTTP_SESSION_VARS];
		$GLOBALS[_ENV] = $GLOBALS[HTTP_ENV_VARS];
		$GLOBALS[_FILES] = $GLOBALS[HTTP_POST_FILES]; // ???
		$GLOBALS[_REQUEST] = array_merge($_GET,$_COOKIE);
	}
	*/

	$path = realpath(__FILE__);

	if($path)
	{
		$path = str_replace("lib/Common.php","",$path);
		$path = str_replace("lib\\Common.php","",$path);
	}

	$include_path = ini_get("include_path");

	/* Setting up include_path for PEAR */

	if(strstr($include_path,';'))
		$include_path = $path . ";" . $path . "lib\\pear;" . $include_path;
	else
		$include_path = $path . ":" . $path . "lib/pear:" . $include_path;

	ini_set("include_path", $include_path);

	ini_set("short_open_tag", "On");

	// magic_quotes on
//	ini_set("magic_quotes_gpc", "1");

	require_once "lib/Settings.php";

	$settings = new Settings($path);

    /**
     * Create alert page
     *
     * @param string $message alert message
     *
     * @param string $href url for move after read alert message
	 *
     * @param string $label label for url
	 *
     * @global object Settings $settings instance of Settings class
	 *
     * @access public
     */

	function alert($message, $href = '', $label = '')
	{
		global $settings;

		if($href == '')
			$action = "history.back()\n";
		else
			$action = "location.replace('$href')\n";

		$skin = $settings->skindir."/alert.php";

		if(!file_exists($skin))
		{
			$message = str_replace("\\","\\\\",$message);
			$message = str_replace("'","`",$message);

			echo "
				<html>
				<head>
				<meta http-equiv=\"Content-Type\" content=\"text/html; charset=" . $settings->encoding . "\">
					<title>". $settings->messages[alert]."</title>
				</head>
				<body bgcolor=white>
				<script>
					var msg = '$message';
					alert(msg);
			";
			echo $action;
			echo"
				</script>
				</body>
				</html>
				";
		}
		else
			include $skin;
		exit;
	}

    /**
     * Change current url
     *
     * @param string $href url for change
	 *
     * @access public
     */

	function redirect($href)
	{
		$skin = $settings->skindir."/redirect.php";

		if(!file_exists($skin))
		{
			if(file_exists($settings->skindir."/redirect.php"))
				include $settings->skindir."/redirect.php";
			else
				echo "<script> location.replace('" . $href . "'); </script>";
		}

		exit;
	}

	if(!function_exists("file_get_contents"))
	{
		function file_get_contents($filename, $use_include_path = 0)
		{
			$data = "";
			$file = @fopen($filename, "rb", $use_include_path);
			if($file)
			{
				while(!feof($file))
					$data .= fread($file, 1024);
				fclose($file);
			}
			return $data;
		}
	}

	// for Sun OS
	if(!function_exists("realpath"))
	{
		function realpath($path)
		{
			// Check if path begins with "/".
			if(strpos($path,"/")==0)
			{
			  $path = $_SERVER['DOCUMENT_ROOT'].$path;
			}
			else
			{
				// Strip slashes and convert to arrays.
				$currentDir = preg_split("/\//",dirname($_SERVER['PATH_TRANSLATED']));
				$newDir = preg_split('/\//',$path);

				// Drop one directory from the array for each ".."; add one otherwise.
				foreach($newDir as $dir)
				{
					if($dir == "..")
						array_pop($currentDir);
					else
						array_push($currentDir,$dir);
				}
				// Return the slashes.
				$path = implode($currentDir,"/");
			}

			return $path;
		} 
	}

?>