<?php
/**
* +----------------------------------------------------------------------+
* | F Board                                                              |
* +----------------------------------------------------------------------+
* | Copyright (c) 2003 Fguy (http://fguy.com)                            |
* +----------------------------------------------------------------------+
* | This software licensed under the GPL license and is provided "as is" |
* | and is without any warranty.                                         |
* |                                                                      |
* | You need to purchase commercial licenses:                            |
* |                                                                      |
* | 1. If you distribute this Software with your non open source         |
* |    software.                                                         |
* | 2. If you want warranty for this software.                           |
* | 3. If you want to support development.                               |
* |                                                                      |
* | Licenses, Support and Training can be easily purchased online.       |
* +----------------------------------------------------------------------+
* | Author: Kang Tae Hoon <fguy@fguy.com>                                |
* +----------------------------------------------------------------------+
*
* ڱ  ȸ, 
*
* @author fguy <fguy@fguy.com>
* @version 0.5
* @access public
* @package FBoard
*/
	require_once "lib/Common.php";
	require_once "lib/String.php";
	require_once "lib/Session.php";
	require_once "lib/Security.php";
	require_once "lib/File.php";
	require_once "lib/SQL.php";
	require_once "lib/Template.php";

	//   
	require_once "constants.php";

	$session = new Session($settings);

	$has_session = $session->hasSession();

	$sql = new SQL($settings);

	// DB 
	$connection = $sql->db->connect($sql->dsn);

	// ASSOC  Fetch mode 
	$connection->setFetchMode(DB_FETCHMODE_ASSOC);

	if(!$session->get("email"))
		alert($settings->messages[cannot_get_member_info]);

	switch($_GET[mode])
	{
		case "modify" :

			// ¥   (-  ν ϹǷ)
			foreach($_POST as $key => $val)
			{
				if(strstr($key, "_date"))
					str_replace("-", "/", $_POST[$key]);
			}

			if($_POST[password] != $_POST[password_confirm])
				alert($settings->messages[password_mismatch]);

			$keys = array("name", "password", "homepage", "subscribe_mailling", "is_private");

			$ext_keys = array("gender", "birth_date", "photo", "phone", "sign",  "introduce");

			$values = $sql->getValidValues($_POST, $keys);

			if(!$_POST[subscribe_mailling])
				$values[subscribe_mailling] = "0";

			if(!$_POST[is_private])
				$values[is_private] = "0";

			if($values[homepage])
				$values[homepage] = String::checkUrl($values[homepage]);

			$ext_values = $sql->getValidValues($_POST, $ext_keys);

			if(!$values[password])
				$values[password] = $session->get("password");

			//  ε
			if($_FILES[photo][size])
				$ext_values[photo] = $session->get("email") . "." . File::getExtension($_FILES[photo][name]);

			if($_FILES[photo][size] && !uploadImage("photo", $ext_values[photo]))
				alert($settings->messages[upload_failed]);

			$result = $connection->autoExecute($settings->prefix . "_member", $values, DB_AUTOQUERY_UPDATE, "email='" . $session->get("email") . "'");

			if(DB::isError($result))
				alert($result->getMessage() . " on " . __FILE__ . " line " . __LINE__);

			$result = $connection->autoExecute($settings->prefix . "_member_ext", $ext_values, DB_AUTOQUERY_UPDATE, "email='" . $session->get("email") . "'");

			if(DB::isError($result))
				alert($result->getMessage() . " on " . __FILE__ . " line " . __LINE__);

			alert($settings->messages[updated], stripslashes($_POST[href]));

			break;

		default : 

			//       
			$query = "select member.*, ext.*,member.email as email from " . $settings->prefix . "_member as member";
			$query .= " left outer join " . $settings->prefix . "_member_ext as ext on member.email = ext.email ";
			$query .= " where member.email = '" . $session->get("email") . "'";

			$member_info = $connection->getRow($query);

			if(DB::isError($member_info))
				alert($settings->messages[invalid_member] . " : " . $member_info->getMessage() . " on " . __FILE__ . " line " . __LINE__);

			$member_point = $connection->getOne("select (login + post + comment + recommend) - opposite from " . $settings->prefix . "_point where email='" . $session->get("email") ."'");

			if(DB::isError($member_info))
				alert($settings->messages[invalid_member] . " : " . $member_info->getMessage() . " on " . __FILE__ . " line " . __LINE__);

			$member_point = intval($member_point);

			$member_info[point] = $member_point;

			$tpl = new Template($settings->skin_path . "_system");

			$tpl->loadTemplatefile("myinfo.html");


			if($member_info[gender] == "m")
			{
				$member_info[gender] = $settings->messages[male];
				$member_info[gender_male_check] = " checked";
			}
			else if($member_info[gender] == "f")
			{
				$member_info[gender] = $settings->messages[female];
				$member_info[gender_female_check] = " checked";
			}
			else
			{
				$member_info[gender] = $settings->messages[unknown];
				$member_info[gender_unknown_check] = " checked";
			}

			if($member_info[subscribe_mailling] == "1")
				$member_info[subscribe_mailling_check] = " checked";

			if($member_info[is_private] == "1")
				$member_info[is_private_check] = " checked";
			
			$member_info[joining_date] = date("Y-m-d", $member_info[joining_date]);
			$member_info[last_login_date] = date("Y-m-d H:i:s", $member_info[last_login_date]);

			if($member_info[photo])
			{
				$imginfo = @getimagesize($settings->uploaded_file_path . "_photo/" . $member_info[photo]);

				if($imginfo[0] > NORMAL_IMG_WIDTH)
				{
					$imgwidth = NORMAL_IMG_WIDTH;
					$imgheight = $imginfo[1] * (NORMAL_IMG_WIDTH / $imginfo[0]);

					$size = "width=".$imgwidth." height=".$imgheight." onclick=\"window.open('view_image.php?imgsrc=" . urlencode(FILE_PATH . "_photos/" . $member_info[photo]) . "','_blank','width=100,height=100,scrollbars=yes');\" style=cursor:hand";
				}
				else
					$size = $imginfo[3];

				$member_info[photo] = "<img src='" . FILE_PATH . "_photos/" . $member_info[photo] . "' border=0 " . $size . ">";

				$member_info[photo_file] = FILE_PATH . "_photos/" . $member_info[photo];
			}

			$tpl->setVariable("ENCODING", $settings->encoding);
			$tpl->setVariable("RETIRE_LINK", LINK_PATH . "joining.php?mode=retire&href=" . $_GET[href]);
			$tpl->setVariable("ACTION", LINK_PATH . "myinfo.php?mode=modify&href=" . $_GET[href]);
			//  ġȯ
			foreach($member_info as $key => $val)
			{
				if($key != "password")
					$tpl->setVariable(strtoupper($key), $val);
			}

			// ޼ ȯ
			foreach($settings->messages as $key => $val)
			{
				$tpl->setVariable("MSG_" . strtoupper($key), $val);
			}

			$tpl->show();
	}

	$connection->disconnect();

	//   ε
	function uploadImage($file_key, $filename)
	{
		global $settings;

		if (!is_uploaded_file($_FILES[$file_key]['tmp_name']))
			return false;
		 
		$_FILES[$file_key]['tmp_name'] = str_replace("\\\\","\\",$_FILES[$file_key]['tmp_name']);

		if(!File::isUploadedImage($_FILES[$file_key]))
			return false;

		if(move_uploaded_file($_FILES[$file_key]['tmp_name'],$settings->uploaded_file_path."_photos/" . $filename))
			return true;

		return false;
	}
?>