<?php
/**
* +----------------------------------------------------------------------+
* | F Board                                                              |
* +----------------------------------------------------------------------+
* | Copyright (c) 2003 Fguy (http://fguy.com)                            |
* +----------------------------------------------------------------------+
* | This software licensed under the GPL license and is provided "as is" |
* | and is without any warranty.                                         |
* |                                                                      |
* | You need to purchase commercial licenses:                            |
* |                                                                      |
* | 1. If you distribute this Software with your non open source         |
* |    software.                                                         |
* | 2. If you want warranty for this software.                           |
* | 3. If you want to support development.                               |
* |                                                                      |
* | Licenses, Support and Training can be easily purchased online.       |
* +----------------------------------------------------------------------+
* | Author: Kang Tae Hoon <fguy@fguy.com>                                |
* +----------------------------------------------------------------------+
*
*   (α/α׾ƿ) 
*
* @author fguy <fguy@fguy.com>
* @version 0.5
* @access public
* @package FBoard
*/
	require_once "lib/Common.php";
	require_once "lib/Session.php";
	require_once "lib/SQL.php";
	require_once "lib/Security.php";
	require_once "lib/Template.php";

	//  
	require_once "constants.php";

	$sql = new SQL($settings);
	$session = new Session($settings);

	$mode = $_GET[mode];
	$href = $_GET[href];

	if(!$href)
		$href = $_POST[href];

	// ̼   Referer  
	if(!$href)
		$href = $_ENV[HTTP_REFERER];

	//   
	$has_session = $session->hasSession();

	// DB 
	$connection = $sql->db->connect($sql->dsn);

	if(DB::isError($connection))
		alert($connection->getMessage());

	switch($mode)
	{
		// α
		case "login" :

			if(!$_POST && !$session->getcookie("login_info"))
				alert($settings->messages[invalid_access], LINK_PATH . "session.php?href=" . $href);

			header("Expires: 0");

			$email = trim($_POST[email]);
			$password = trim($_POST[password]);
			$auto_login = isset($_POST[auto_login]);

			//  ϸ Pass
			if($has_session)
				redirect($href);

			$password = Security::encrypt($password);

			// ڵ α   ʵ  
			if($session->getcookie("login_info"))
				parse_str($session->getcookie("login_info"));

			$query = "select name from " . $settings->prefix . "_member where email='" . $email . "' and password='" . $password . "' and status='0'";

			$row = $connection->getOne($query);

			// α
			if($row && !DB::isError($row))
			{
				//   
				$query = "select joining_date from " . $settings->prefix . "_member where email='" . $email . "'";

				$joining_date = $connection->getOne($query);

				if($joining_date < 1)
				{
					$tpl = new Template($settings->skin_path . "_system");

					$tpl->loadTemplatefile("require_email_verification.html",true, true);

					$tpl->setVariable("EMAIL", $email);

					$tpl->setVariable("HREF", $href);

					$tpl->setVariable("SEND_LINK", LINK_PATH . "joining.php?mode=request_verify&email=" . $email . "&href=" . urlencode($href));

					// ޼ ȯ
					foreach($settings->messages as $key => $val)
					{
						$tpl->setVariable("MSG_" . strtoupper($key), $val);
					}

					$tpl->setVariable("ENCODING", $settings->encoding);

					$tpl->show();
					exit;
				}

				// ڵ α Ű 
				if($auto_login)
					setcookie("login_info","email=" . $email . "&password=" . $password ,time()+3600*24*14);

				$session->set("email", $email);
				$session->set("password", $password);
				$session->set("name", $row);

				if($email == $settings->admin)
					$session->set("is_admin", true);

				// Ʈ
				$points = parse_ini_file($path."conf/points.ini");

				$connection->query("update " . $settings->prefix . "_point set login = login + " . $points[login] . " where email='" . $email . "'");

				$connection->query("update " . $settings->prefix . "_member set last_login_ip = '" . $_SERVER["REMOTE_ADDR"] . "', last_login_date =  " . time() . " where email='" . $email . "'");

				//  η ̵
				redirect($href);
			}
			// α Ұ
			else
			{
				$query = "select count(1) from " . $settings->prefix . "_member where email='" . $email . "' and password='" . $password . "' and status='1'";
				// Ż 
				$check = intval($connection->getOne($query));
				if($check)
					alert($settings->messages[retired_user]);
				alert($settings->messages[login_failed]);
			}
			break;

		// α׾ƿ
		case "logout" :

			if($session->getcookie("login_info"))
				$session->deletecookie("login_info");
			$session->destroy();

			redirect($href);

			break;

		// α 
		default :

			// ̹ α Ǿ ִ 
			if ($has_session)
				redirect($href);
			// α  
			else
			{
				// ڵ α   α
				if($session->getcookie("login_info"))
					redirect(LINK_PATH . "session.php?mode=login&href=" . urlencode($href));


				$tpl = new Template($settings->skin_path . "_system");

				$tpl->loadTemplatefile("login.html",true, true);

				// ޼ ȯ
				foreach($settings->messages as $key => $val)
				{
					$tpl->setVariable("MSG_" . strtoupper($key), $val);
				}

				$tpl->setVariable("HREF", $href);
				$tpl->setVariable("EMAIL", $login_info[email]);
				$tpl->setVariable("PASSWORD", $login_info[password]);
				$tpl->setVariable("ACTION", LINK_PATH . "session.php?mode=login");
				$tpl->setVariable("JOINING_LINK", LINK_PATH . "joining.php?href=" . $href);
				
				// ũƮ  ð
				$tpl->setVariable("EXECUTE_TIME",get_exec_time());

				$tpl->setVariable("ENCODING",$settings->encoding);

				$tpl->show();
			}
	}

	// DB  
	$connection->disconnect();
?>