<?php
/**
* +----------------------------------------------------------------------+
* | F Board                                                              |
* +----------------------------------------------------------------------+
* | Copyright (c) 2003 Fguy (http://fguy.com)                            |
* +----------------------------------------------------------------------+
* | This software licensed under the GPL license and is provided "as is" |
* | and is without any warranty.                                         |
* |                                                                      |
* | You need to purchase commercial licenses:                            |
* |                                                                      |
* | 1. If you distribute this Software with your non open source         |
* |    software.                                                         |
* | 2. If you want warranty for this software.                           |
* | 3. If you want to support development.                               |
* |                                                                      |
* | Licenses, Support and Training can be easily purchased online.       |
* +----------------------------------------------------------------------+
* | Author: Kang Tae Hoon <fguy@fguy.com>                                |
* +----------------------------------------------------------------------+
*
* Խ ġ 
*
* @author fguy <fguy@fguy.com>
* @version 0.5
* @access public
* @package FBoard
*/
	require_once "lib/Common.php";
	require_once "lib/SQL.php";
	require_once "lib/String.php";
	require_once "lib/Security.php";
	require_once "lib/Schema.php";
	require_once "lib/Session.php";
	require_once "lib/Template.php";

	define("LICENSE_FILE", "LICENSE");

	$step = $_GET[step];

	$sql = new SQL($settings);

	$connection = $sql->db->connect($sql->dsn);

	if(DB::isError($connection))
		alert($connection->getMessage() . " (Check your DSN in " . $settings->setting_file . ")","doc/whats_dsn.txt","What is DSN?");

	if($settings->admin)
		alert($settings->messages[already_installed]);

	switch($step)
	{
		// ġ 1ܰ - ġ , 丮 ۹̼ üũ, DB  Է
		default :

			$tpl = new Template($settings->skin_path . "_admin");

			$tpl->loadTemplatefile("setup.html",true, true);


			if(!is_writable($settings->path))
			{
				$tpl->setCurrentBlock("change_target");
				$tpl->setVariable("CHANGE_TARGET_DIR",$settings->path);
				$tpl->parseCurrentBlock("change_target");
			}

			if(!is_writable($settings->setting_file))
			{
				$tpl->setCurrentBlock("change_target");
				$tpl->setVariable("CHANGE_TARGET_DIR",$settings->setting_file);
				$tpl->parseCurrentBlock("change_target");
			}

			// ޼ ȯ
			foreach($settings->messages as $key => $val)
			{
				$tpl->setVariable(strtoupper($key), $val);
			}

			// ̼
			$fd = fopen (LICENSE_FILE, "r");
			$tpl->setVariable("LICENSE", fread($fd, filesize (LICENSE_FILE)));
			fclose ($fd);

			clearstatcache();

			$tpl->setVariable("ENCODING",$settings->encoding);

			// ũƮ  ð
			$tpl->setVariable("EXECUTE_TIME",get_exec_time());

			$tpl->show();

			break;
		// ġ 2ܰ - DB Ű    
		case 2 :

			if(!$_POST)
				alert($settings->messages[invalid_access]);


			if(!is_writable($settings->path))
				alert($settings->messages[failed_to_mkdir]);
			if(!is_writable($settings->setting_file))
				alert($settings->messages[failed_to_create_setting]);

			// 丮 
			@mkdir($settings->session_save_path,0777) or alert($settings->messages[failed_to_mkdir]);
			@mkdir($settings->uploaded_file_path,0777) or alert($settings->messages[failed_to_mkdir]);
			@mkdir($settings->uploaded_file_path . "_photos",0777) or alert($settings->messages[failed_to_mkdir]);

			// ʵ    ...
			foreach($_POST as $key => $val)
			{
				if(String::isBlank($val))
					alert($key . $settings->messages[is_required]);
			}

			$values = $_POST;
			// password_confirm   
			array_pop($values);
			$values[password] = Security::encrypt($values[password]);
			$values[joining_date] = time();
			$values[status] = "0";
			$values[is_private] = "1";

			// ⺻ ̺ 
			$schema = new Schema($settings, $sql);
			if(!$schema->createBasicTablesFromXML($connection))
				alert($setting->messages[failed_to_create_basic_tables]);

			//   
			$fp = fopen($settings->setting_file,"r");

			$setting_contents = fread($fp, filesize($settings->setting_file)) . "\r\nadmin\t\t\t\t= " . $_POST[email];

			fclose($fp);

			$fp = fopen($settings->setting_file,"w");

			fwrite($fp, $setting_contents);

			fclose($fp);

			$result = $connection->autoExecute($settings->prefix . "_member", $values);

			if(DB::isError($result))
				alert($result->getMessage() . ". in " . __FILE__ . " on line " . __LINE__);

			$values = array("email" => $_POST[email]);

			$result = $connection->autoExecute($settings->prefix . "_member_ext", $values);

			if(DB::isError($result))
				alert($result->getMessage() . ". in " . __FILE__ . " on line " . __LINE__);


			$values = array("gid" => 1 , "email" => $_POST[email], "authorized" => "1");

			$result = $connection->autoExecute($settings->prefix . "_group_members", $values);

			if(DB::isError($result))
				alert($result->getMessage() . ". in " . __FILE__ . " on line " . __LINE__);

			$values = array("email" => $_POST[email]);

			$result = $connection->autoExecute($settings->prefix . "_point", $values);

			if(DB::isError($result))
				alert($result->getMessage() . ". in " . __FILE__ . " on line " . __LINE__);

			$session = new Session($settings);

			$session->set("is_admin",true);
			$session->set("email",$_POST[email]);
			$session->set("name",$_POST[name]);
			$session->set("password",$password);

			redirect("admin.php");

			break;

	}
	// DB  
	$connection->disconnect();

?>