<?php
/**
* +----------------------------------------------------------------------+
* | F Board                                                              |
* +----------------------------------------------------------------------+
* | Copyright (c) 2003 Fguy (http://fguy.com)                            |
* +----------------------------------------------------------------------+
* | This software licensed under the GPL license and is provided "as is" |
* | and is without any warranty.                                         |
* |                                                                      |
* | You need to purchase commercial licenses:                            |
* |                                                                      |
* | 1. If you distribute this Software with your non open source         |
* |    software.                                                         |
* | 2. If you want warranty for this software.                           |
* | 3. If you want to support development.                               |
* |                                                                      |
* | Licenses, Support and Training can be easily purchased online.       |
* +----------------------------------------------------------------------+
* | Author: Kang Tae Hoon <fguy@fguy.com>                                |
* +----------------------------------------------------------------------+
*
* Խù ۼ//
*
* @author fguy <fguy@fguy.com>
* @version 0.5
* @access public
* @package FBoard
*/
	require_once "lib/Image.php";
	require_once "lib/Email.php";

	define(EXT_INI_FILE, $path . "conf/extension.ini");

	$article = new Article($settings, $connection, $_GET[id], $_GET[num]);

	if($config[type] == "calendar" && $article->data[reg_date])
	{
		$year = date("Y", $article->data[reg_date]);
		$month = date("m", $article->data[reg_date]);
	}

	switch($_GET[mode])
	{
		case "write" :
		case "modify" :

			if(!$_POST)
				alert($settings->messages[invalid_access]);

			$values = $_POST;

			//  üũ
			if($_GET[type] == "reply" && ($grant[grant_reply] && ($my_grant < $grant[grant_reply])))
				alert($settings->messages[no_grant_reply]);
			else if($grant[grant_post] && ($my_grant < $grant[grant_post]))
				alert($settings->messages[no_grant_write]);

			//   
			if($_GET[mode] != "modify" && $type != "reply" && $config[papering_standard] > 0)
			{
				$result = $connection->limitQuery("select body from " . $settings->prefix . "_" . $_GET[id] . "_board where level = 0 order by num desc", 0, 1);

				if(DB::isError($result))
					alert($result->getMessage() . " on " . __FILE__ . " line " . __LINE__);

				$row = $result->fetchRow();

				$result->free();

				$previous_article = $row[0];

				$similarity = String::getSimilarity($previous_article,$_POST[body]);

				if($similarity >= $config[papering_standard])
					alert($settings->messages[papering_head] . $similarity . $settings->messages[papering_tail]);

				unset($previous_article);
			}

			// ܾ 
			if($config[use_filtering] == "y")
			{
				$fd = fopen(BAD_WORDS_FILE, "r");
				$contents = fread($fd, filesize (BAD_WORDS_FILE));
				fclose ($fd);

				$badwords = split(",", $contents);

				unset($contents);

				for($i=0;$i<count($badwords);$i++)
				{
					$badwords[$i] = trim($badwords[$i]);

					if(@eregi($badwords[$i], $_POST[body]) || @eregi($badwords[$i],$_POST[name]) || @eregi($badwords[$i],$_POST[subject]) || @eregi($badwords[$i],$_POST[email]) || @eregi($badwords[$i],$_POST[homepage]))
					{
						if($checked_badwords)
							$checked_badwords .= ", ".$badwords[$i];
						else
							$checked_badwords = $badwords[$i];
					}
				}
				if($checked_badwords)
					alert($checked_badwords.$settings->messages[badword]);
			}

			// α  Ż ڵԷ
			if($has_session)
			{
				$values[password] = $member[password];
				$values[email] = $session->get("email");
			}
			// α  ʾ   Ű 
			else
			{
				if(!$session->getcookie("user_info") || $session->getcookie("user_info") != "name=" . $_POST[name] . "&email=" . $_POST[email] . "&homepage=" . $_POST[homepage])
					setcookie("user_info","name=" . $_POST[name] . "&email=" . $_POST[email] . "&homepage=" . $_POST[homepage] , time()+3600*24*365);

				$values[password] = Security::encrypt($_POST[password]);
			}
			//  ̻ ۼ
			if ($_POST[notice] && $my_grant < $grant[grant_notice])
				alert($settings->messages[no_grant]);
			//  ׿ ݵ н Է
			if (($_POST[notice] && String::isBlank($_POST[password])) && $my_grant < USER_SYSOP)
				alert($settings->messages[notice_need_password]);

			// Խù    üũ (sysop ̻  üũ )
			if($_GET[mode] == "modify" && $values[password] != $article->data[password] && !($has_session && ($my_grant >= USER_SYSOP)))
			{
				alert($settings->messages[not_match_password]);
			}

			// ʵ üũ
			if(!$has_session && String::isBlank($_POST[name]))
				alert($settings->messages[need_name]);
			else if(String::isBlank($_POST[subject]) && String::isBlank($_POST[body]))
				alert($settings->messages[need_subject_or_body],"");
			else if(!$has_session && !String::isEmail($_POST[email]) && !String::isBlank($_POST[email]))
				alert($settings->messages[invalid_email]);

			// ۾   level, depth  ʱȭ
			if($_GET[type] != "reply" && $_GET[mode] != "modify")
			{
				$values[level] = 0;
				$values[depth] = 0;
			}
			//    Ʈ  ״ ̾
			else if ($_GET[mode] == "modify")
			{
				if($article->data[parent] < NOTICE_PARENT && !$_POST[notice])
					$values[parent] = "-" . $_GET[num];
			}
			//   parent  level 
			else
			{

				$values[depth] = $article->data[depth] + 1;

				$values[parent] = $article->data[parent];

				$values[num] = '-' . $_GET[num];

				if($article->data[parent] < NOTICE_PARENT)
					alert($settings->messages[no_reply_to_notice]);

				$result2 = $connection->query("update " . $settings->prefix . "_" . $_GET[id] . "_board set level = level + 1 where parent = " . $article->data[parent] . " and level > " . $article->data[level]);

				$values[level] = $article->data[level] + 1;


				// 亯  ߼

				$parent = $article->getParent();

				if($parent[reply_mail])
				{
					echo "<li> Post an email to original writer..... ";

					require_once "lib/Email.php";

					$email = new Email($settings);

					if($parent[members])
					{
						$result = $connection->query("select name, email from " . $settings->prefix . "_member where email = '" . $parent[email] . "'");

						$row = $result->fetchRow(DB_FETCHMODE_ORDERED);

						$email->receiver_email = $row[1];
						$email->receiver_name = $row[0];
					}
					else
					{
						$email->receiver_email = $parent[email];
						$email->receiver_name = $parent[name];
					}
					
					
					if($email->receiver_email)
					{
						$email->charset = $settings->encoding;

						if(!$has_session)
						{
							if($values[email])
								$email->sender_email = $values[email];

							if($values[name])
								$email->sender_name = $values[name];
							else if($values[email])
								$email->sender_name = $values[email];
						}
						else
						{
							$result = $connection->query("select name, email from " . $settings->prefix . "_member where email = '" . $session->get("email") . "'");

							$row = $result->fetchRow(DB_FETCHMODE_ORDERED);

							$email->sender_email = $row[1];
							$email->sender_name = $row[0];

						}


						if(String::isBlank($values[subject]))
							$email->subject = "\"" . $parent[subject] . "\"'s Reply";
						else
							$email->subject = $values[subject];

						$email->body = "[This is the " . $parent[subject] . "'s reply]\n\n" . $values[body];

						if($article->data[html])
						{
							$email->body = nl2br($email->body);
							$email->content_type = "text/html";
						}

						else
							$email->content_type = "text/plain";

						if(@$email->send())
							echo "OK!<br>";
						else
							echo "Failure!<br>";
					}
					else
						echo "Failure!<br>";

					unset($email);
				}
			}

			// url տ http://   
			$values[homepage] = String::checkUrl($values[homepage]);

			//  ۼ   num  
			if($_GET[mode] == "write")
			{
				$values[num] = $connection->getOne("select max(num)+1 from " . $settings->prefix . "_" . $_GET[id] . "_board");

				if(!$values[num] || DB::isError($values[num]))
					$values[num] = 1;
				if(!$values[parent])
					$values[parent] = "-" . $values[num];
			}
			else
				$values[num] = $_GET[num];

			//   parent ʵ带  ο
			if($_POST[notice])
			{
				$values[parent] = $connection->getOne("select max(parent) + 1 from " . $settings->prefix . "_" . $_GET[id] . "_board where parent < " . NOTICE_PARENT);

				if(!$values[parent] || DB::isError($values[parent]))
					$values[parent] = NOTICE_PARENT - 1;
			}


			// phase 
			if($_GET[type] != "reply")
			{
				$phase = $values[num] / PHASE_LIMIT;

				if($phase <= 1)
					$phase = 1;
				else
				{
					$phase = floor($phase) + 1;
					$phase = intval($phase);
				}
			}
			else if($_GET[mode] == "write")
			{
				$phase = $article->data[phase];
			}

			$values[phase] = $phase;

			//  
			if($_POST[remove])
			{
				$remove_list = array_keys($_POST[remove]);

				foreach($remove_list as $remove_seq)
				{
					echo "<li> Removing file... ";

					$remove_target = $connection->getOne("select name from " . $settings->prefix . "_files where board_id=" . $_GET[id] . " and board_num= " . $_GET[num] . " and seq = " . $remove_seq);

					@unlink($settings->uploaded_file_path  . $_GET[id] . "/" . $_GET[num] . "/" . $remove_target);
					@exec("rm -rf " . $settings->uploaded_file_path  . $_GET[id] . "/" . $_GET[num] . "/" . $remove_target);

					@$connection->query("delete from " . $settings->prefix . "_files where board_id=" . $_GET[id] . " and board_num= " . $_GET[num] . " and seq = " . $remove_seq);

					echo "OK!";
				}
			}

			//  ε
			if($_FILES["file"] && $config[use_upload] == "y")
			{
				$extension = parse_ini_file(EXT_INI_FILE);

				$files = $_FILES["file"];

				$files_length = count($files[size]);

				for($i = 0; $i < $files_length; $i++)
				{
					if($files['size'][$i] > 0)
					{
						echo "<li> Uploading..... ";
						// ߺǴ  ε Ұ
						if(!@in_array($files['name'][$i].$files['size'][$i], $filelist))
						{
							if(!is_uploaded_file($files[tmp_name][$i]))
							{
								echo "Error!";
								alert($settings->messages[invalid_file]);
							}


							// ϸ   ũ üũ
							if($my_grant < $grant[grant_full_upload])
							{
								if(!$extension[allow] && $extension[deny])
								{
									// ε Ұ  
									$exts = split(",", $extension[deny]);

									foreach($exts as $ext)
									{
										$ext = strtolower(trim($ext));

										if(strtolower(Parts::getExtension($files[name][$i])) == $ext)
											alert($settings->messages[invalid_file_extension]);
									}
								}
								else if($extension[allow])
								{
									// ε   ƴ  
									$exts = split(",", $extension[allow]);

									foreach($exts as $ext)
									{
										$ext = strtolower(trim($ext));

										if(strtolower(Parts::getExtension($files[name][$i])) != $ext)
											alert($settings->messages[invalid_file_extension]);
									}
								}
								if($files[size][$i] > $config[max_file_size])
									alert($settings->messages[too_large_file]);
							}

							if(!is_dir($settings->uploaded_file_path  . $_GET[id]))
								@mkdir($settings->uploaded_file_path  . $_GET[id],0777);
							if(!is_dir($settings->uploaded_file_path  . $_GET[id] . "/" . $values[num]))
								@mkdir($settings->uploaded_file_path  . $_GET[id] . "/" . $values[num], 0777);

							$files[tmp_name][$i] = str_replace("\\\\","\\",$files[tmp_name][$i]);

							$files[name][$i] = str_replace(" ","_",$files[name][$i]);

							$save_name = urlencode($files[name][$i]);

							move_uploaded_file($files[tmp_name][$i] , $settings->uploaded_file_path . $_GET[id] . "/" . $values[num] . "/" . $save_name);

							chmod( $settings->uploaded_file_path . $_GET[id] . "/" . $values[num] . "/" . $save_name , 0666);

							if($_POST[make_thumbnail] && Parts::isImage($files[name][$i]))
							{
								Image::getThumbnail($config, $settings->uploaded_file_path . $_GET[id] . "/" . $values[num] . "/" . $save_name);
							}

							// file ̺  ȣ ο
							$files[num][$i] = $connection->getOne("select max(num) + 1 from " . $settings->prefix . "_files");

							if(!$files[num][$i] || DB::isError($files[num][$i]))
								$files[num][$i] = 1;

							$file_exists = $connection->getOne("select count(1) from " . $settings->prefix . "_files where board_id=". $_GET[id] . " and board_num=" . $values[num] . " and seq=" . $i);

							if($_GET[mode] == "modify" && $file_exists > 0)
							{
								$f_values = array("name" => $files[name][$i], "size" => $files[size][$i], "type" => $files[type][$i]);

								$where = "board_id = " . $_GET[id] . " and board_num	 = " . $values[num] . " and seq = " . $i;

								$query_mode = DB_AUTOQUERY_UPDATE;
							}
							else
							{
								$file_keys = array("num", "name", "size", "type", "board_id", "board_num", "seq");

								$f_values = array("num" => $files[num][$i], "name" => $files[name][$i], "size" => $files[size][$i], "type" => $files[type][$i], "board_id" => $_GET[id], "board_num" => $values[num], "seq" => $i);

								$query_mode = DB_AUTOQUERY_INSERT;

								$where = "";
							}

							$result = $connection->autoExecute($settings->prefix . "_files", $f_values, $query_mode, $where);

							if(DB::isError($result))
								alert($result->getMessage() . " on " . __FILE__ . " line " . __LINE__);

							echo "OK!<br>";
							$filelist[] = $files['name'][$i].$files['size'][$i];
						}
						else
						{
							echo "SKIP. Aleady exists!<br>";
						}
					}
				}
				unset($filelist);
			}

			if(!$_POST[reg_date] && ($_GET[type] == "reply" || !$article->data[reg_date]))
				$values[reg_date] = time();
			else if($_POST[reg_date])
			{
				$values[reg_date] = strtotime($_POST[reg_date]);
			}

			$values[ip] = $_SERVER[REMOTE_ADDR];

			// ̺ 
//				@$connection->query("lock tables");

			if($values[html] > 1)
				$values[body] = eregi_replace("<html>|</html>|<head.*head>|<body>|</body>","",$values[body]);

			if($has_session)
				$values[members] = "1";

			// ۾  insert
			if($_GET[mode] == "write")
			{
				echo "<li> Writing..... ";

				$keys = array("num", "name", "email", "password", "homepage", "members", "ip", "category", "subject", "body", "reg_date", "reply_mail", "html", "private", "related_link", "phase", "parent", "level", "depth");

				$values = $sql->getValidValues($values, $keys);

				$result = $connection->autoExecute($settings->prefix . "_" . $_GET[id] . "_board", $values);

				if(DB::isError($result))
					alert($result->getMessage() . " on " . __FILE__ . " line " . __LINE__);


				$max_phase = $connection->getOne("select max(phase) from " . $settings->prefix . "_phase where id=" . $_GET[id]);

				if($phase > $max_phase)
				{
					$values = array("id" => $_GET[id], "phase" => $phase, "cnt" => 1);

					$connection->autoExecute($settings->prefix . "_phase", $values);
				}
				else
				{
					$result = $connection->query("update " . $settings->prefix . "_phase set cnt = cnt + 1 where id=" . $_GET[id] . " and phase=" . $phase);

					if(DB::isError($result))
					{
						alert($result->getMessage() . " on " . __FILE__ . " line " . __LINE__);
					}
				}
				//    Ʈ ο
				if($has_session)
				{
					$connection->query("update " . $settings->prefix . "_point set post = post + " . $points[post] . " where email='" . $session->get("email") . "'");
				}

			}
			//   update
			else if($_GET[mode] == "modify")
			{
				echo "<li> Updating..... ";

				$keys = array("name", "email", "password", "homepage", "ip", "category", "subject", "body", "reply_mail", "html", "private", "related_link", "reg_date");

				$values = $sql->getValidValues($values, $keys);

				$result = $connection->autoExecute($settings->prefix . "_" . $_GET[id] . "_board", $values, DB_AUTOQUERY_UPDATE, " num = " . $_GET[num]);

				if(DB::isError($result))
					alert($result->getMessage() . " on " . __FILE__ . " line " . __LINE__);
			}

			// insert Ǵ update 
			if($result)
			{
				echo "OK!";

				// ڿ Ϸ 뺸
				if($_GET[mode] == "write" && $config[use_inform_to_admin] == "y")
				{
				echo "<li> Send an email to Administrator..... ";
					$email = new Email($settings);

					$result = $connection->query("select email, name from " . $settings->prefix . "_member where email = '" . $settings->admin ."'");

					if(!DB::isError($result))
					{
						$row = $result->fetchRow(DB_FETCHMODE_ORDERED);

						$email->receiver_email = $row[0];
						$email->receiver_name = $row[1];
						$email->subject = "[Aricle Notify] " . stripslashes($values[subject]);
						$email->body = $values[body];
						if(!$has_session)
						{
							$email->sender_name = $values[name];
							$email->sender_email = $values[email];
							$email->reply_to = $values[email];
						}
						else
						{
							$row = $result->fetchRow(DB_FETCHMODE_ORDERED);
							$email->sender_email =  $session->get("email");
							$email->sender_name =  $session->get("name");
							$email->reply_to = $session->get("email");
						}
						$email->content_type = $values[html];
						$email->charset	= $settings->encoding;

						if($email->send())
							echo "OK!";
						else
							echo "Failure!";
					}
					else
						echo "Failure!";
				}


				if($_POST[href])
					redirect($_POST[href]);
				else if($_GET[href])
					redirect($_GET[href]);
				if($config[type] != "calendar")
				{
					if($_GET[type] == "reply" || isset($_GET[goindex]))
						redirect(LINK_NAME . "?id=" . $_GET[id] . "&page=" . $_GET[page] . "&" . $_GET[search_mode]);
					else if($_GET[mode] == "write")
						redirect(LINK_NAME . "?id=" . $_GET[id]) . "&" . $_GET[search_mode];
					else
						redirect(LINK_NAME . "?module=view&id=" . $_GET[id] . "&num=" . $_GET[num] . "&page=" . $_GET[page] . "&" . $_GET[search_mode]);
				}
				else
				{
					if($_GET[mode] == "write")
					{
						redirect(LINK_NAME . "?id=" . $_GET[id] . "&year=" . date("Y", $values[reg_date]) . "&month=" . date("m", $values[reg_date]));
					}
					else
						redirect(LINK_NAME . "?id=" . $_GET[id] . "&year=" . $year . "&month=" . $month);
				}

			}
			// н
			else
			{
				echo "Error!";
				alert($settings->messages[failed_to_write]);
			}

			// ̺  
//				@$connection->query("unlock tables");

			break;

		case "show_delete_form" :

			$result = $connection->getOne("select count(1) from " . $settings->prefix . "_" .  $_GET[id] . "_board where parent= " . $article->data[parent] . " and level > " . $article->data[level]);

			if(DB::isError($result))
			{
				alert($result->getMessage() . " on " . __FILE__ . " line " . __LINE__);
			}

			if($my_grant < $grant[grant_delete] && $result > 0)
				alert($settings->messages[cannot_del_has_reply]);

			//   Ǹ     ʰ ٷ 
			if(($has_session && ($my_grant > $grant[grant_delete])) || ($article->data[id] && $session->get("id") == $article->data[id]))
			{

				/************************************ Խù   **************************************/

				$phase = $connection->getOne("select phase from " . $settings->prefix . "_" . $_GET[id] . "_board where num=" . $_GET[num]);

				if(DB::isError($phase))
				{
					alert($phase->getMessage() . " on " . __FILE__ . " line " . __LINE__);
				}

				// PHASE 
				$connection->query("update " . $settings->prefix . "_phase set cnt = cnt - 1 where id =" . $_GET[id] . " and phase=" . $phase);

				// Խù 
				$connection->query("delete from " . $settings->prefix . "_" . $_GET[id] . "_board where num=" . $_GET[num]);

				// ڸƮ 
				$connection->query("delete from " . $settings->prefix . "_" . $_GET[id] . "_comment where parent=" . $_GET[num]);

				if(is_dir($settings->uploaded_file_path))
				{
					@$connection->query("delete from " . $settings->prefix . "_files where board_id=" . $_GET[id] . " and board_num = " . $_GET[num]);

					if(!@exec("rm -rf " . $settings->uploaded_file_path  . $_GET[id] . "/" . $_GET[num]))
					{
						$result = $connection->query("select name from " . $settings->prefix . "_files where board_id=" . $_GET[id] . " and board_num = " . $_GET[num]);

						while($row = $result->fetchRow(DB_FETCHMODE_ORDERED))
						{
							@unlink($settings->uploaded_file_path  . $_GET[id] . "/" . $_GET[num] . "/" . urlencode($row[0]));
						}
					}
				}

				// Ʈ 
				$connection->query("update " . $settings->prefix . "_point set post = post - " . $points[post] . " where email='" . $session->get("email") . "'");
				
				if($config[type] != "calendar")
					redirect(LINK_NAME . "?id=" . $_GET[id] . "&page=" . $_GET[page] . "&" . $_GET[search_mode]);
				else
					redirect(LINK_NAME . "?id=" . $_GET[id] . "&year=" . $year . "&month=" . $month);


				/************************************ Խù    **************************************/
			}
			else
			{
				$tpl = new Template($skin_path);

				$tpl->loadTemplatefile("delete.html");

				// ޼ ȯ
				foreach($settings->messages as $key => $val)
				{
					$tpl->setVariable("MSG_" . strtoupper($key), $val);
				}

				$tpl->setVariable("PAGE",$_GET[page]);

				$tpl->setVariable("MODE", "delete");

				$tpl->setVariable("NUM",$_GET[num]);

				$tpl->setVariable("ID",$_GET[id]);

				$tpl->setVariable("HEADER",$header);

				$tpl->setVariable("FOOTER",$footer);

				$tpl->setVariable("SKIN_PATH",SKIN_PATH);

				$tpl->setVariable("TITLE",$config[name]);

				$tpl->setVariable("VIEW_NUM",$_GET[view_num]);

				$tpl->setVariable("ACTION",LINK_NAME . "?module=write&mode=delete&num=" . $_GET[num] . "&id=" . $_GET[id] . "&page=" . $_GET[page] . "&view_num=" . $_GET[view_num] . "&search_mode=" . urlencode($_GET[search_mode]));

				$tpl->show();
			}

			break;
		
		case "delete" :

			if(String::isBlank($_POST[password]))
				alert($settings->messages[invalid_password]);

			if($article->data[password] == Security::encrypt($_POST[password]))
			{
				/************************************ Խù   **************************************/

				$phase = $connection->getOne("select phase from " . $settings->prefix . "_" . $_GET[id] . "_board where num=" . $_GET[num]);

				if(DB::isError($phase))
				{
					alert($phase->getMessage() . " on " . __FILE__ . " line " . __LINE__);
				}

				// PHASE 
				$connection->query("update " . $settings->prefix . "_phase set cnt = cnt - 1 where id =" . $_GET[id] . " and phase=" . $phase);

				// Խù 
				$connection->query("delete from " . $settings->prefix . "_" . $_GET[id] . "_board where num=" . $_GET[num]);

				// ڸƮ 
				$connection->query("delete from " . $settings->prefix . "_" . $_GET[id] . "_comment where parent=" . $_GET[num]);

				if(is_dir($settings->uploaded_file_path))
				{
					@$connection->query("delete from " . $settings->prefix . "_files where board_id=" . $_GET[id] . " and board_num = " . $_GET[num]);

					if(!@exec("rm -rf " . $settings->uploaded_file_path  . $_GET[id] . "/" . $_GET[num]))
					{
						$result = $connection->query("select name from " . $settings->prefix . "_files where board_id=" . $_GET[id] . " and board_num = " . $_GET[num]);

						while($row = $result->fetchRow(DB_FETCHMODE_ORDERED))
						{
							@unlink($settings->uploaded_file_path  . $_GET[id] . "/" . $_GET[num] . "/" . urlencode($row[0]));
						}
					}
				}

				//    Ʈ 
				if($has_session)
					@$connection->query("update " . $settings->prefix . "_point set post = post - " . $point[post] . " where email='" . $session->get("email") . "'");

				if($config[type] != "calendar")
					redirect(LINK_NAME . "?id=" . $_GET[id] . "&page=" . $_GET[page] . "&" . $_GET[search_mode]);
				else
					redirect(LINK_NAME . "?id=" . $_GET[id] . "&year=" . $year . "&month=" . $month);

				/************************************ Խù    **************************************/
			}
			else
				alert($settings->messages[invalid_password]);

			break;

		default :
			//  üũ
			if($_GET[mode] == "reply" && ($grant[grant_reply] && ($my_grant < $grant[grant_reply])))
				alert($settings->messages[no_grant_reply]);
			else if(!$_GET[mode] && ($grant[grant_post] && ($my_grant < $grant[grant_post])))
			{	
				if($has_session)
					alert($settings->messages[no_grant_write]);
				else
					alert($settings->messages[no_grant_write], LINK_PATH . "session.php?href=" . urlencode(LINK_NAME. "?module=" . $_GET[module] . "&id=" . $_GET[id]));
			}

			
			$tpl = new Template($skin_path);

			$tpl->loadTemplatefile("write.html");

			
			// ȣ    ۼ  ƴ
			if($_GET[num])
			{
				if($_GET[mode] == "edit")
				{
					$file_info = $article->getAttachFileInfo();

					$subject = stripslashes($article->data[subject]);

					$body = String::removeBr(stripslashes($article->data[body]));
					$related_link = String::removeTags($article->data[related_link]);
					$name = String::removeTags($article->data[name]);
					$email = String::removeTags($article->data[email]);
					$homepage = String::removeTags($article->data[homepage]);
				}
				if($_GET[mode] == "reply")
				{
					$subject = stripslashes($article->data[subject]);

					if(String::isBlank($subject))
						$subject = $settings->messages[nosubject];

					$subject = "Re:".$subject;

					// Ʈ      ۼ  ο 
					if($config[use_body_in_list] == "y")
						$body = "";
					else
					{
						$body = str_replace("\n","\n> ",stripslashes($article->data[body]));
						$body = String::removeBr($body);
						if(!$article->data[name])
							$article->data[name] = $article->data[member_name];

						$body = "\n\n\n".$article->data[name]." wrote at ". date("Y-m-d H:i:s", $article->data[reg_date]) . "\n> ". $body;
					}
				}

				$subject = str_replace("\"","&#34",$subject);  // ' ó

				$body = String::removeNbsp($body); // nbsp;   ġȯ
			}

			// īװ 
			if($config[use_category] == "y")
			{
				$categories = $article->getCategories();

				$category_options = "";

				$tpl->touchBlock("category");

				$tpl->setVariable("MSG_CATEGORY",$settings->messages[category]);

				foreach($categories as $category)
				{
					$tpl->setVariable("CATEGORY_NUM",$category[num]);

					$tpl->setVariable("CATEGORY_LABEL",$category[label]);

					if($_GET[num] && $_GET[mode] == "edit" && $category[num] == $article->data[category])
						$tpl->setVariable("CATEGORY_SELECTED"," selected");

					if(!PEAR::isError($tpl->setCurrentBlock("category_options")))
					{
						$tpl->parseCurrentBlock("category_options");
					}
				}

			}


			if($_GET[mode] == "reply")
			{
				//     
				if($article->data[parent] < NOTICE_PARENT)
					alert($settings->messages[no_reply_to_notice]);

				$type = "reply";
			}

		
			if($_GET[mode] != "edit")
			{
				// Ű    Ű Ľ
				if(!$has_session && $session->getcookie("user_info"))
					parse_str($session->getcookie("user_info"));

				$mode = "write";
			}
			else
				$mode = "modify";

			// Էʵ ܿ
			if($has_session && $article->data[members] && ($article->data[email] == $session->get("email")))
				$ellipsisable = true;
			else if(!$has_session || (($has_session && $my_grant < USER_SYSOP) && $mode != "write"))
			{
				$ellipsisable = false;
			}
			else
				$ellipsisable = true;

			if($config[use_html] == "y")
			{
				$tpl->touchBlock("html");
				$tpl->setVariable("MSG_HTML", $settings->messages[html]);
				if($article->data[html])
					$tpl->setVariable("HTML_CHECK", "checked");
			}

			//   ۼ 
			if($my_grant >= $grant[grant_notice])
			{
				$tpl->touchBlock("notice");
				$tpl->setVariable("MSG_NOTICE", $settings->messages[notice]);

				if($_GET[mode] && $article->data[parent] < NOTICE_PARENT)
					$tpl->setVariable("NOTICE_CHECK", "checked");
			}


			if($config[use_related_link] == "y")
			{
				$tpl->touchBlock("related_link");
				$tpl->setVariable("MSG_RELATED_LINK", $settings->messages[related_link]);

				if($article->data[related_link])
					$tpl->setVariable("RELATED_LINK", $related_link);
			}

			if($config[use_upload] == "y")
			{
				$tpl->touchBlock("upload");
	
				$tpl->setVariable("MSG_MAX_FILE_SIZE", String::convertSize($config[max_file_size]));
				$tpl->setVariable("MSG_ATTACH_FILE", $settings->messages[attach_file]);
				if(count($file_info) > 0)
				{
					$i = 0;
					foreach($file_info as $file)
					{
						if(!PEAR::isError($tpl->setCurrentBlock("attach_file")))
						{
							$tpl->setVariable("FILE_NUM", $i);
							$tpl->setVariable("FILE_SEQ", $file[seq]);
							$tpl->setVariable("FILE_NAME", $file[name]);
							$tpl->setVariable("DOWNLOAD_LINK", LINK_NAME . "?module=download&id=" . $_GET[id] . "&num=" . $file[num]);
							$tpl->setVariable("FILE_SIZE", String::convertSize($file[size]));
							$tpl->setVariable("FILE_ICON", Parts::getIcon($file[name]));
							$tpl->setVariable("FILE_PATH", FILE_PATH . $_GET[id] . "/" . $file[board_num] . "/" . urlencode(urlencode($file[name])));

							$tpl->parseCurrentBlock();
							$i++;
						}
					}
				}
			}


			if($_GET[mode] == "edit" && $article->data[level] == 0 && $article->data[reply_mail])
				$tpl->setVariable("REPLY_MAIL_CHECK", "checked");

			if(!$_GET[mode] || ($_GET[mode] == "edit" && $article->data[level] == 0))
			{
				$tpl->touchBlock("reply_mail");
				$tpl->setVariable("MSG_REPLY_MAIL", $settings->messages[reply_mail]);
			}

			$tags_ini = file_get_contents($settings->path."conf/allowable_tags.ini");

			$tpl->setVariable("ALLOWABLE_TAGS", $tags_ini);

			unset($tags_ini);

			$tpl->setVariable("PAPERING_STANDARD", $config[papering_standard]);

			$tpl->setVariable("PAGE",$_GET[page]);

			$tpl->setVariable("MODE",$mode);

			$tpl->setVariable("NUM",$_GET[num]);

			$tpl->setVariable("TYPE",$type);

			$tpl->setVariable("ID",$_GET[id]);

			$tpl->setVariable("SUBJECT",$subject);

			$tpl->setVariable("BODY",$body);

			$tpl->setVariable("HEADER",$header);

			$tpl->setVariable("FOOTER",$footer);

			$tpl->setVariable("SKIN_PATH",SKIN_PATH);

			$tpl->setVariable("TITLE",$config[name]);

			if($article->data[reg_date])
			{
				// ¥
				foreach($date_format as $key => $val)
				{
					$tpl->setVariable(strtoupper($key), date($val, $article->data[reg_date]));
				}
			}

			$tpl->setVariable("ACTION", LINK_NAME . "?module=write&id=". $_GET[id] . "&num=". $_GET[num] . "&mode=" . $mode . "&page=" . $_GET[page] . "&type=" . $type . "&search_mode=" . urlencode($_GET[search_mode]));


			//   ޼ ȯ ʵ ϱ Ͽ..
			$selectable_keys = array("password", "name", "homepage", "email", "category", "notice", "html", "related_link", "attach_file", "reply_mail");

			// ޼ ȯ
			foreach($settings->messages as $key => $val)
			{
				if(!in_array(strtolower($key), $selectable_keys))
					$tpl->setVariable("MSG_" . strtoupper($key), $val);
			}

			if(!$ellipsisable)
			{
				$tpl->touchBlock("personal_info");

				$tpl->setVariable("MSG_PASSWORD", $settings->messages[password]);
				$tpl->setVariable("MSG_NAME", $settings->messages[name]);
				$tpl->setVariable("MSG_HOMEPAGE", $settings->messages[homepage]);
				$tpl->setVariable("MSG_EMAIL", $settings->messages[email]);

				$tpl->setVariable("NAME",$name);
				$tpl->setVariable("EMAIL",$email);
				$tpl->setVariable("HOMEPAGE",$homepage);

			}

			$tpl->show();

			break;
	}
?>