<?php
/**
* +----------------------------------------------------------------------+
* | F Board                                                              |
* +----------------------------------------------------------------------+
* | Copyright (c) 2003 Fguy (http://fguy.com)                            |
* +----------------------------------------------------------------------+
* | This software licensed under the GPL license and is provided "as is" |
* | and is without any warranty.                                         |
* |                                                                      |
* | You need to purchase commercial licenses:                            |
* |                                                                      |
* | 1. If you distribute this Software with your non open source         |
* |    software.                                                         |
* | 2. If you want warranty for this software.                           |
* | 3. If you want to support development.                               |
* |                                                                      |
* | Licenses, Support and Training can be easily purchased online.       |
* +----------------------------------------------------------------------+
* | Author: Kang Tae Hoon <fguy@fguy.com>                                |
* +----------------------------------------------------------------------+
*
*  
*
* @author fguy <fguy@fguy.com>
* @version 0.5
* @access public
* @package FBoard
*/

	require_once "lib/Schema.php";

	$schema = new Schema($settings, $sql);

	switch($_GET[mode])
	{
		//   
		case "update" :

			$keys = array("grant_read","grant_post","grant_reply","grant_delete","grant_comment","grant_full_html","grant_notice","grant_download","grant_full_upload");

			$values = $sql->getValidValues($_POST, $keys);

			$result = $connection->autoExecute($settings->prefix . "_board_privileges", $values, DB_AUTOQUERY_UPDATE, "id=" . $_POST[id]);

			if(DB::isError($result))
				alert($settings->messages[failed_to_update] . " " . $result->getMessage() . " on " . __FILE__ . " line " . __LINE__);

//			redirect("admin.php?module=privilege&id=" . $_POST[id]);
			alert($settings->messages[updated], "admin.php?module=privilege&id=" . $_POST[id]);
			
			break;


		//    
		default :

			$board_name = $connection->getOne("select name from " . $settings->prefix . "_board_config where id = " . $_GET[id]);

			$tpl = new Template($settings->skin_path . "_admin");

			$tpl->loadTemplatefile("privilege.html",true, true);

			$tpl->setVariable("ID", $_GET[id]);

			$tpl->setVariable("NAME", $board_name);

			$tpl->setVariable("ENCODING", $settings->encoding);

			// ޼ ȯ
			foreach($settings->messages as $key => $val)
			{
				$tpl->setVariable("MSG_" . strtoupper($key), $val);
			}

			$result = $connection->query("select * from " . $settings->prefix . "_board_privileges where id=" . $_GET[id]);

			if(DB::isError($result))
			{
				alert($result->getMessage() . " on " . __FILE__ . " line " . __LINE__);
			}

			if($result->numRows() < 1)
				alert($settings->messages[not_exists]);

			$row = $result->fetchRow(DB_FETCHMODE_ASSOC);

			unset($result);

			//  ȯ
			foreach($row as $key => $val)
			{
				$tpl->setVariable(strtoupper($key), $val);
			}


			$tpl->show();

	}
?>