<?php
/**
* +----------------------------------------------------------------------+
* | F Board                                                              |
* +----------------------------------------------------------------------+
* | Copyright (c) 2003 Fguy (http://fguy.com)                            |
* +----------------------------------------------------------------------+
* | This software licensed under the GPL license and is provided "as is" |
* | and is without any warranty.                                         |
* |                                                                      |
* | You need to purchase commercial licenses:                            |
* |                                                                      |
* | 1. If you distribute this Software with your non open source         |
* |    software.                                                         |
* | 2. If you want warranty for this software.                           |
* | 3. If you want to support development.                               |
* |                                                                      |
* | Licenses, Support and Training can be easily purchased online.       |
* +----------------------------------------------------------------------+
* | Author: Kang Tae Hoon <fguy@fguy.com>                                |
* +----------------------------------------------------------------------+
*
*  ƿƼ Ŭ
*
* @author fguy <fguy@fguy.com>
* @version 0.5
* @access public
* @package FBoard
*/

class File
{
    /**
     * ε   ̹  
     *
     * @param object $file ε  ü
	 *
     * @return bool ̹  
     *
     * @access public
     */
	function isUploadedImage($file)
	{
		$tmp = explode("/",$file['type']);
		if(eregi($tmp[0],"image"))
			return 1;
		return 0;
	}

    /**
     *  Ȯ 
     *
     * @param string $file_name	ϸ 
	 *
     * @return string  Ȯ
     *
     * @access public
     */

	function getExtension($file_name)
	{
		$extension = strtolower(substr(strrchr($file_name,"."),1));

		return $extension;
	}

    /**
     *  ۹̼ 
     *
     * @param string $file_name	ϸ 
	 *
     * @return string  ۹̼ (ڸ)
     *
     * @access public
     */
	function getPermission($file_name)
	{
		$decperms = fileperms($file_name);
		$octalperms = sprintf("%o",$decperms);
		return (substr($octalperms,3));
	}

    /**
     *   ִ  
     *
     * @param string $file_name	ϸ 
	 *
     * @return bool б  
     *
     * @access public
     */
	function isReadable($file_name)
	{
		$perms=fileperms($file_name); 

		if ($perms & 00400 || $perms & 00040 || $perms & 00004)
			return true;
		return false;
	}

    /**
     *    
     *
     * @param string $file_name	ϸ 
	 *
     * @return bool   
     *
     * @access public
     */
	function isWritable($file_name)
	{
		$perms=fileperms($file_name);

		if ($perms & 00200 || $perms & 00020 || $perms & 00002)
			return true;
		return false;
	}

    /**
     *    
     *
     * @param string $file_name	ϸ 
	 *
     * @return bool   
     *
     * @access public
     */
	function isExcutable($file_name)
	{
		$perms=fileperms($file_name);

		if ($perms & 00100 || $perms & 00010 || $perms & 00001)
			return true;
		return false;
	}
}