<?php
/**
* +----------------------------------------------------------------------+
* | F Board                                                              |
* +----------------------------------------------------------------------+
* | Copyright (c) 2003 Fguy (http://fguy.com)                            |
* +----------------------------------------------------------------------+
* | This software licensed under the GPL license and is provided "as is" |
* | and is without any warranty.                                         |
* |                                                                      |
* | You need to purchase commercial licenses:                            |
* |                                                                      |
* | 1. If you distribute this Software with your non open source         |
* |    software.                                                         |
* | 2. If you want warranty for this software.                           |
* | 3. If you want to support development.                               |
* |                                                                      |
* | Licenses, Support and Training can be easily purchased online.       |
* +----------------------------------------------------------------------+
* | Author: Kang Tae Hoon <fguy@fguy.com>                                |
* +----------------------------------------------------------------------+
*
* Security function library.
*
* @author fguy <fguy@fguy.com>
* @version 0.5
* @access public
* @package FBoard
*/

class Parts
{
	//  
	function getPages($page,$total,$list_per_page,$pages,$link)
	{
		$link = eregi_replace("\&page=.+","",$link);

		$total_page = ceil($total/$list_per_page);

		if(!$page)
			$page=1;
		if($page > $total_page)
			$page = $total_page;

		$prev_page = $page-1;
		$next_page = $page+1;

		$head_dot = $foot_dot = "...";
		$prev_page = $prev_page.$search_mode.$sort;
		$next_page = $next_page.$search_mode.$sort;
		$first_page = "<a href=\"$link&page=1\"><font class=page>[first]</font></a>";
		$last_page = "<a href=\"$link&page=$total_page\"><font class=page>[last]</font></a>";

		for($i=$page-floor($pages/2);$i<=$page-floor($pages/2)-1+$pages;$i++)
		{
			if($i >= 1 && $i <= $total_page)
			{
				if($page == $i)
					$page_list .= "[<font class=pageSelected>$i</font>]";
				else
					$page_list .= "<a href=\"$link&page=$i\"><font class=page>[$i]</font></a>";
			}
			if($i == 1)
			{
				$head_dot = "";
				$first_page = "";
			}
			if($i == $total_page)
			{
				$foot_dot = "";
				$last_page = "";
			}
		}
		return "<font class=page>".$first_page." ".$head_dot." ".$page_list." ".$foot_dot." ".$last_page."</font>";
	}

	//  ŸԿ   
	function getIcon($file_name)
	{
		$ext = Parts::getExtension($file_name);

		if(!String::isBlank($file_name))
		{
			if(eregi("aif|aifc|aiff|arj|asf|au|avi|bat|bmp|cdf|cgi|com|css|dif|dll|doc|dv|eml|exe|gif|gz|htm|hwp|iff|jfif|jpeg|jpg|js|lhz|lzh|mac|mht|mid|mov|mp2|mp3|nws|pcx|png|ppt|ps|psd|qif|qt|qtif|ra|rle|rpm|rv|spl|swf|sys|tar|txt|tgz|tgz|tif|wav|wma|wmf|xls|z|zip",$ext))
				$type = strtolower($ext);
			else
				$type = "unknown";

			$icon ="<img src=\"" . LINK_PATH . "icons/".$type.".gif\"  border=\"0\" align=\"absmiddle\" alt=\"file name : $file_name\" />";

			return $icon;
		}
	}

	//  Ȯڸ 
	function getExtension($file_name)
	{
		$filename = trim($file_name);
		preg_match('/\.([0-9a-zA-Z]{1,4})$/', $file_name, $result);
		return $result[1];
	}

	// ̹  
	function isImage($file_name)
	{
		$extension = strtolower(Parts::getExtension($file_name));
		if(ereg("gif|jpg|jpeg|png",$extension))
			return true;
		return false;
	}

}