<?php
/**
* +----------------------------------------------------------------------+
* | F Board                                                              |
* +----------------------------------------------------------------------+
* | Copyright (c) 2003 Fguy (http://fguy.com)                            |
* +----------------------------------------------------------------------+
* | This software licensed under the GPL license and is provided "as is" |
* | and is without any warranty.                                         |
* |                                                                      |
* | You need to purchase commercial licenses:                            |
* |                                                                      |
* | 1. If you distribute this Software with your non open source         |
* |    software.                                                         |
* | 2. If you want warranty for this software.                           |
* | 3. If you want to support development.                               |
* |                                                                      |
* | Licenses, Support and Training can be easily purchased online.       |
* +----------------------------------------------------------------------+
* | Author: Kang Tae Hoon <fguy@fguy.com>                                |
* +----------------------------------------------------------------------+
*
* ˻ 
*
* @author fguy <fguy@fguy.com>
* @version 0.5
* @access public
* @package FBoard
*/
require_once "lib/String.php";
require_once "lib/SQL.php";

class Search
{
	function doKeywordHighlight(&$row)
	{
		$keyword = SQL::stripSlashes(trim($_GET[keyword]));

		$highlight = "<font class=keyword>".$keyword."</font>";

		$search_fields = array("comment", "subject", "body", "name", "category");

		if(String::isBlank($_GET[s_subject]) && String::isBlank($_GET[s_body]) && String::isBlank($_GET[s_name]) && String::isBlank($_GET[s_file]) && String::isBlank($_GET[s_comment]))
				$no_search_option = true;
		else
			$no_search_option = false;

		foreach($row as $key => $val)
		{
			if(@in_array($key, $search_fields) && ($no_search_option || $_GET["s_" . $key]))
			{
				$row[$key] = SQL::stripSlashes(str_replace($keyword, $highlight, $row[$key]));
			}
		}
	}
}
?>