<?php
/**
* +----------------------------------------------------------------------+
* | F Board                                                              |
* +----------------------------------------------------------------------+
* | Copyright (c) 2003 Fguy (http://fguy.com)                            |
* +----------------------------------------------------------------------+
* | This software licensed under the GPL license and is provided "as is" |
* | and is without any warranty.                                         |
* |                                                                      |
* | You need to purchase commercial licenses:                            |
* |                                                                      |
* | 1. If you distribute this Software with your non open source         |
* |    software.                                                         |
* | 2. If you want warranty for this software.                           |
* | 3. If you want to support development.                               |
* |                                                                      |
* | Licenses, Support and Training can be easily purchased online.       |
* +----------------------------------------------------------------------+
* | Author: Kang Tae Hoon <fguy@fguy.com>                                |
* +----------------------------------------------------------------------+
*
* Setting Interfaces
*
* @author fguy <fguy@fguy.com>
* @version 0.5
* @access public
* @package FBoard
*/

class Settings
{
	var $prefix			= "FBoard";
	var $setting_file	= "conf/settings.ini.php";
	var $language		= "ko";
	var $dsn			= "";
	var $path			= "";
	var $encoding		= "utf-8";
	var $session_save_path = "sessions";
	var $uploaded_file_path = "";
	var $skin_path		= "skins";
	var $messages		= array();

	var $admin		= "";

	function Settings($path)
	{
		$this->path		= str_replace("\\", "/", $path);
		$this->setting_file = $this->path . $this->setting_file;

		$settings = parse_ini_file($this->setting_file);

		$this->dsn		= $settings[dsn];

		if(strtolower(trim($settings[language])) == "auto" && file_exists($this->path . "conf/languages/" . $_SERVER["HTTP_ACCEPT_LANGUAGE"] . ".ini"))
		{
			$this->language = $_SERVER["HTTP_ACCEPT_LANGUAGE"];
		}
		else if(file_exists($this->path . "conf/languages/" . $settings[language] . ".ini"))
		{
			$this->language = $settings[language];
		}

		$this->encoding = $settings[encoding];
		$this->session_save_path = $this->path.$settings['session_save_path'];
		$this->skin_path = $this->path.$settings[skin_path]."/";
		$this->messages = parse_ini_file($this->path . "conf/languages/" . $this->language . ".ini");

		$this->uploaded_file_path = $this->path.$settings['uploaded_file_path']."/";

		$this->admin = $settings[admin];
	}

	function setSettings($key, $val)
	{
		eval("\$this->" . $key . "=\$val");
	}

	function saveSettingFile()
	{/*
		//   
		$fp = @fopen($this->setting_file,"w");

		//   
		fwrite($fp,$dbconf);
		fclose($fp);		
		*/
	}
}
?>